//////////////////////////////////////////////////////////////////////////
//	"devntscsi.cpp"
//------------------------------------------------------------------------
//	$Id: devntscsi.cpp 30 2003-12-09 07:39:09Z  $
//////////////////////////////////////////////////////////////////////////

#include	<windows.h>
#include	<stddef.h>
#include	<tchar.h>
#include	<stdio.h>
#include	<ctype.h>
#include	"devctl.h"

int		DevCtl::ScsiGetAddress(SCSI_ADDRESS & scsiAddr)
{
	DWORD	dwSize;

	scsiAddr.Length = sizeof(scsiAddr);
	if ( this->DeviceIoControl(IOCTL_SCSI_GET_ADDRESS, NULL, 0,  &scsiAddr, sizeof(scsiAddr), &dwSize) == 0 )
		return -1;
	return 0; //(int)dwSize;
}

// (SCSI_ADAPTER_BUS_INFO) + (NumberOfBuses -1) * sizeof(SCSI_BUS_DATA)) + (InquiryDataSize * NumberOfLUs), 
// InquiryDataSize = (sizeof(SCSI_INQUIRY_DATA) - 1 + INQUIRYDATABUFFERSIZE)

int		DevCtl::ScsiGetInquiryData(unsigned size, void * buffer)
{
	DWORD	dwSize;

	if ( this->DeviceIoControl(IOCTL_SCSI_GET_INQUIRY_DATA,  NULL, 0,  buffer, size, &dwSize) == 0 )
		return -1;
	return (int)dwSize;
}

DevCtl::ScsiDevData *	DevCtl::ScsiGetInquiryData(void)
{
	BYTE				buffer[4096];
	int					size;
	ScsiDevData		   *devData = NULL;
	int				retcode;

	if ( (size = this->ScsiGetInquiryData(sizeof(buffer), buffer)) <= 0 )
		return NULL;
	if ( (devData = new ScsiDevData) == NULL )
		return NULL;

	try
	{
		SCSI_ADAPTER_BUS_INFO	*pa;

		pa = (SCSI_ADAPTER_BUS_INFO *) buffer;
		if ( (devData->numBus = pa->NumberOfBuses) > 0 )
		{
			unsigned				i;
			SCSI_INQUIRY_DATA		*pi;

			if ( (devData->busData = new ScsiBusData [devData->numBus]) == NULL )
				throw -1;
			for ( i = 0; i < devData->numBus; i++ )
			{
				SCSI_BUS_DATA			*pb;
				int						j;

				pb = &pa->BusData[i];
				devData->busData[i].numUnits = 0;
				devData->busData[i].busId = pa->BusData[i].InitiatorBusId;
				pi = (SCSI_INQUIRY_DATA *) (buffer + pa->BusData[i].InquiryDataOffset);
				while ( pa->BusData[i].InquiryDataOffset )
				{
					devData->busData[i].numUnits++;
					if ( pi->NextInquiryDataOffset == 0 )
						break;
					pi = (SCSI_INQUIRY_DATA *) (buffer + pi->NextInquiryDataOffset);
				}
				if ( devData->busData[i].numUnits == 0 )
					continue;
				if ( (devData->busData[i].inqData = new ScsiInqData [devData->busData[i].numUnits]) == NULL )
					throw -1;
				pi = (SCSI_INQUIRY_DATA *) (buffer + pa->BusData[i].InquiryDataOffset);
				j = 0;
				while ( pa->BusData[i].InquiryDataOffset )
				{
					ScsiInqData	   *inqData;

					inqData = &devData->busData[i].inqData[j];
					inqData->pathId     = pi->PathId;
					inqData->targetId   = pi->TargetId;
					inqData->lun        = pi->Lun;
					inqData->devClaimed = pi->DeviceClaimed;
					if ( (inqData->size = pi->InquiryDataLength) > 0 )
					{
						if ( (inqData->data = new BYTE [inqData->size]) == NULL )
							throw -1;
						memcpy(inqData->data, pi->InquiryData, inqData->size);
					}
					j++;
					if ( pi->NextInquiryDataOffset == 0)
						break;
					pi = (SCSI_INQUIRY_DATA *) (buffer + pi->NextInquiryDataOffset);
				}
			}
		}
		retcode = 0;
	}
	catch (int ret) { retcode = ret;}
	if ( retcode < 0 && devData != NULL )
	{
		delete devData;
		devData = NULL;
	}
	return devData;
}


int		DevCtl::ScsiCreateInqData(DevCtl::ScsiInqData & inqData, int pathId, int targetId, int lun)
{
	SCSIINQUIRY	inq;

	if ( this->ScsiInquiry(pathId, targetId, lun, -1, sizeof(inq), &inq) < 0 )
		return -1;
	inqData.pathId     = pathId;
	inqData.targetId   = targetId;
	inqData.lun        = pathId;
	inqData.devClaimed = FALSE;
	inqData.size       = sizeof(inq);
	if ( inqData.data != NULL )
		delete [] inqData.data;
	if ( (inqData.data = new BYTE [sizeof(inq)]) == NULL )
		return -1;
	memcpy(inqData.data, &inq, sizeof(inq));

	return 0;
}

//////////////////////////////////////////////////////////////////////////
//	 ScsiDevData

DevCtl::ScsiDevData::ScsiDevData()
{
	this->numBus = 0;
	this->busData = NULL;
}

DevCtl::ScsiDevData::~ScsiDevData()
{
	if ( this->busData != NULL )
	{
		delete [] this->busData;
		this->busData = NULL;
	}
}

//////////////////////////////////////////////////////////////////////////
//	 ScsiBusData

DevCtl::ScsiBusData::ScsiBusData()
{
	this->numUnits = 0;
	this->busId = 0;
	this->inqData = NULL;
}

DevCtl::ScsiBusData::~ScsiBusData()
{
	if ( this->inqData != NULL )
	{
		delete [] this->inqData;
		this->inqData = NULL;
	}
}

//////////////////////////////////////////////////////////////////////////
//	 ScsiInqData

DevCtl::ScsiInqData::ScsiInqData()
{
	this->pathId     = 0;
	this->targetId   = 0;
	this->lun        = 0;
	this->devClaimed = FALSE;
	this->size       = 0;
	this->data       = NULL;
	this->unknownId  = FALSE;
}

DevCtl::ScsiInqData::~ScsiInqData()
{
	if ( this->data != NULL )
	{
		delete [] this->data;
		this->data = NULL;
	}
}

int		DevCtl::ScsiGetCapabilities(IO_SCSI_CAPABILITIES & capa)
{
	DWORD	dwSize;

	if ( this->DeviceIoControl(IOCTL_SCSI_GET_CAPABILITIES,  NULL, 0,  &capa, sizeof(capa), &dwSize) == 0 )
		return -1;
	return 0;
}

int		DevCtl::ScsiPassThrough(unsigned insize, SCSI_PASS_THROUGH * inspt, unsigned outsize, SCSI_PASS_THROUGH * outspt)
{
	DWORD	dwSize;

	if ( this->DeviceIoControl(IOCTL_SCSI_PASS_THROUGH, (void *)inspt, insize, (void *)outspt, outsize, &dwSize) == 0 )
		return -1;
	return (int)dwSize;
}

int		DevCtl::ScsiPassThroughDirect(unsigned insize, SCSI_PASS_THROUGH_DIRECT * inspt, unsigned outsize, SCSI_PASS_THROUGH_DIRECT * outspt)
{
	DWORD	dwSize;

	if ( this->DeviceIoControl(IOCTL_SCSI_PASS_THROUGH_DIRECT, (void *)inspt, insize, (void *)outspt, outsize, &dwSize) == 0 )
		return -1;
	return (int)dwSize;
}

int		DevCtl::ScsiCheckCondition(BYTE * senseData)
{
	if ( senseData[7] < 10 )
		return 0;	// error
	return senseData[12] == 0x23 || senseData[12] == 0x28 ? 1 : 0;
}

int		DevCtl::ScsiInquiry(int pathId, int targetId, int lun, int pageCode, unsigned size, void * buffer)
{
	SPT_BUFFER			spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = SCSI_CDB6_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = size;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBufferOffset   = offsetof(SPT_BUFFER, buffer);
		spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
		spt.spt.Cdb[0]             = 0x12; // Inqurity
		spt.spt.Cdb[1]             = (lun << 5) + (pageCode < 0 ? 0 : 1);
		spt.spt.Cdb[2]             = pageCode < 0 ? 0 : pageCode;
	//	spt.spt.Cdb[3]             = 0;
		spt.spt.Cdb[4]             = size;
	//	spt.spt.Cdb[5]             = 0;
		outsize = offsetof(SPT_BUFFER, buffer) + spt.spt.DataTransferLength;
		if ( (ret = this->ScsiPassThrough(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				memcpy( buffer, spt.buffer, size);
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}


int		DevCtl::ScsiTestUnitReady(int pathId, int targetId, int lun)
{
	SPT_BUFFER			spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = SCSI_CDB6_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = 0;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBufferOffset   = offsetof(SPT_BUFFER, buffer);
		spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
		spt.spt.Cdb[0]             = 0x00; // TEST UNIT READY
		spt.spt.Cdb[1]             = lun << 5;
	//	spt.spt.Cdb[2]             = 0;
	//	spt.spt.Cdb[3]             = 0;
	//	spt.spt.Cdb[4]             = 0;
	//	spt.spt.Cdb[5]             = 0;
		outsize = offsetof(SPT_BUFFER, buffer) + spt.spt.DataTransferLength;
		if ( (ret = this->ScsiPassThrough(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

int		DevCtl::ScsiModeSense(int pathId, int targetId, int lun, int pageCode, unsigned size, void * buffer)
{
	SPT_DIRECT_BUFFER	spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH_DIRECT));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH_DIRECT);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = size < 256 ? SCSI_CDB6_LEN : SCSI_CDB10_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = size;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBuffer         = buffer;
		spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
		if ( size < 256 )
		{
			spt.spt.Cdb[0]         = 0x1A; // MODE SENSE(6)
			spt.spt.Cdb[1]         = lun << 5;
			spt.spt.Cdb[2]         = pageCode & 0x3F;
		//	spt.spt.Cdb[3]         = 0;
			spt.spt.Cdb[4]         = (BYTE)size;
		//	spt.spt.Cdb[5]         = 0;
		} else
		{
			spt.spt.Cdb[0]         = 0x5A; // MODE SENSE(10)
			spt.spt.Cdb[1]         = lun << 5;
			spt.spt.Cdb[2]         = pageCode & 0x3F;
		//	spt.spt.Cdb[3]         = 0;
		//	spt.spt.Cdb[4]         = 0;
		//	spt.spt.Cdb[5]         = 0;
		//	spt.spt.Cdb[6]         = 0;
			spt.spt.Cdb[7]         = (BYTE)((size >> 8) & 0xFF);
			spt.spt.Cdb[8]         = (BYTE)( size       & 0xFF);
		//	spt.spt.Cdb[9]         = 0;
		}
		outsize = sizeof(spt);
		if ( (ret = this->ScsiPassThroughDirect(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

#if 0
int		DevCtl::ScsiModeSense(int pathId, int targetId, int lun, int pageCode, unsigned size, void * buffer)
{
//#define	USE_DIRECT
#ifdef	USE_DIRECT
	SPT_DIRECT_BUFFER	spt;
#else
	SPT_BUFFER			spt;
#endif
	unsigned			outsize;
	int					ret;

	for (;;)
	{
#ifdef	USE_DIRECT
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH_DIRECT));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH_DIRECT);
#else
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH);
#endif
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = SCSI_CDB6_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = size;
		spt.spt.TimeOutValue       = this->scsi_timeout;
#ifdef	USE_DIRECT
		spt.spt.DataBuffer         = buffer;
#else
		spt.spt.DataBufferOffset   = offsetof(SPT_BUFFER, buffer);
#endif
		spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
		spt.spt.Cdb[0]             = 0x1A; // SCSIOP_MODE_SENSE;
		spt.spt.Cdb[1]             = lun << 5;
		spt.spt.Cdb[2]             = pageCode; // MODE_SENSE_RETURN_ALL;
		spt.spt.Cdb[3]             = 0;
		spt.spt.Cdb[4]             = (BYTE)size;
		spt.spt.Cdb[5]             = 0;
#ifdef	USE_DIRECT
		outsize = sizeof(spt);
		if ( (ret = this->ScsiPassThroughDirect(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
#else
		outsize = offsetof(SPT_BUFFER, buffer) + spt.spt.DataTransferLength;
		if ( (ret = this->ScsiPassThrough(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
#endif
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
#ifdef	USE_DIRECT
#else
				memcpy( buffer, spt.buffer, size);
#endif
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}
#endif

int		DevCtl::ScsiReadCapacity(int pathId, int targetId, int lun, unsigned size, void * buffer)
{
	SPT_BUFFER			spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = SCSI_CDB10_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = size;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBufferOffset   = offsetof(SPT_BUFFER, buffer);
		spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
		spt.spt.Cdb[0]             = 0x25; // Read Capacity
		spt.spt.Cdb[1]             = lun << 5;
	//	spt.spt.Cdb[2]             = 0;
	//	spt.spt.Cdb[3]             = 0;
	//	spt.spt.Cdb[4]             = 0;
	//	spt.spt.Cdb[5]             = 0;
	//	spt.spt.Cdb[6]             = 0;
	//	spt.spt.Cdb[7]             = 0;
	//	spt.spt.Cdb[8]             = 0;	// 0x01 == Num of Sec
	//	spt.spt.Cdb[9]             = 0;
		outsize = offsetof(SPT_BUFFER, buffer) + spt.spt.DataTransferLength;
		if ( (ret = this->ScsiPassThrough(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
			{
				INT64	n;

				n = this->ScsiGetLBA((BYTE *)spt.buffer) + 1I64;
				this->ScsiSetLBA((BYTE *)spt.buffer, n);
				memcpy( buffer, spt.buffer, size);
				return 0;
			}

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

int		DevCtl::ScsiRead(int pathId, int targetId, int lun, INT64 addr, unsigned count, unsigned size, void * buffer)
{
	SPT_DIRECT_BUFFER	spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH_DIRECT));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH_DIRECT);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = SCSI_CDB10_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = size;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBuffer         = buffer;
		spt.spt.SenseInfoOffset    = offsetof(SPT_DIRECT_BUFFER, senseArea);
		spt.spt.Cdb[0]             = 0x28; // Read
		spt.spt.Cdb[1]             = lun << 5;
		spt.spt.Cdb[2]             = (BYTE)((addr >> 24) & 0xFF);
		spt.spt.Cdb[3]             = (BYTE)((addr >> 16) & 0xFF);
		spt.spt.Cdb[4]             = (BYTE)((addr >>  8) & 0xFF);
		spt.spt.Cdb[5]             = (BYTE)( addr        & 0xFF);
	//	spt.spt.Cdb[6]             = 0;
		spt.spt.Cdb[7]             = (BYTE)((count >> 8) & 0xFF);
		spt.spt.Cdb[8]             = (BYTE)( count       & 0xFF);
	//	spt.spt.Cdb[9]             = 0;
		outsize = sizeof(spt);
		if ( (ret = this->ScsiPassThroughDirect(sizeof(SCSI_PASS_THROUGH_DIRECT), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				return (int) spt.spt.DataTransferLength;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

int		DevCtl::ScsiVerify(int pathId, int targetId, int lun, INT64 addr, unsigned count)
{
	SPT_BUFFER			spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = SCSI_CDB10_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = 0;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBufferOffset   = offsetof(SPT_BUFFER, buffer);
		spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
		spt.spt.Cdb[0]             = 0x2F; // Verify
		spt.spt.Cdb[1]             = lun << 5;
		spt.spt.Cdb[2]             = (BYTE)((addr >> 24) & 0xFF);
		spt.spt.Cdb[3]             = (BYTE)((addr >> 16) & 0xFF);
		spt.spt.Cdb[4]             = (BYTE)((addr >>  8) & 0xFF);
		spt.spt.Cdb[5]             = (BYTE)( addr        & 0xFF);
	//	spt.spt.Cdb[6]             = 0;
		spt.spt.Cdb[7]             = (BYTE)((count >> 8) & 0xFF);
		spt.spt.Cdb[8]             = (BYTE)( count       & 0xFF);
	//	spt.spt.Cdb[9]             = 0;
		outsize = sizeof(spt);
		if ( (ret = this->ScsiPassThrough(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

int		DevCtl::ScsiSeek(int pathId, int targetId, int lun, INT64 addr)
{
	SPT_BUFFER			spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = SCSI_CDB10_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = 0;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBufferOffset   = offsetof(SPT_BUFFER, buffer);
		spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
		spt.spt.Cdb[0]             = 0x2B; // Seek
		spt.spt.Cdb[1]             = lun << 5;
		spt.spt.Cdb[2]             = (BYTE)((addr >> 24) & 0xFF);
		spt.spt.Cdb[3]             = (BYTE)((addr >> 16) & 0xFF);
		spt.spt.Cdb[4]             = (BYTE)((addr >>  8) & 0xFF);
		spt.spt.Cdb[5]             = (BYTE)( addr        & 0xFF);
	//	spt.spt.Cdb[6]             = 0;
	//	spt.spt.Cdb[7]             = 0;
	//	spt.spt.Cdb[8]             = 0;
	//	spt.spt.Cdb[9]             = 0;
		outsize = offsetof(SPT_BUFFER, buffer) + spt.spt.DataTransferLength;
		if ( (ret = this->ScsiPassThrough(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

int		DevCtl::ScsiReadToc(int pathId, int targetId, int lun, BOOL msf, unsigned size, void * buffer)
{
	SPT_DIRECT_BUFFER	spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH_DIRECT));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH_DIRECT);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = SCSI_CDB10_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = size;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBuffer         = buffer;
		spt.spt.SenseInfoOffset    = offsetof(SPT_DIRECT_BUFFER, senseArea);
		spt.spt.Cdb[0]             = 0x43; // Read Toc
		spt.spt.Cdb[1]             = (lun << 5) + (msf ? 0x02 : 0);
	//	spt.spt.Cdb[2]             = 0;
	//	spt.spt.Cdb[3]             = 0;
	//	spt.spt.Cdb[4]             = 0;
	//	spt.spt.Cdb[5]             = 0;
	//	spt.spt.Cdb[6]             = 0;
		spt.spt.Cdb[7]             = (BYTE)((size >> 8) & 0xFF);
		spt.spt.Cdb[8]             = (BYTE)( size       & 0xFF);
	//	spt.spt.Cdb[9]             = 0;
		outsize = sizeof(spt);
		if ( (ret = this->ScsiPassThroughDirect(sizeof(SCSI_PASS_THROUGH_DIRECT), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

int		DevCtl::ScsiReadToc(int pathId, int targetId, int lun, BOOL msf, DevCtl::SCSITOCDATA & toc)
{
	return this->ScsiReadToc(pathId, targetId, lun, msf, sizeof(toc), &toc);
}

int		DevCtl::ScsiReadDefectData(int pathId, int targetId, int lun, unsigned list, unsigned fmt, unsigned size, void * buffer)
{
	SPT_DIRECT_BUFFER	spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH_DIRECT));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH_DIRECT);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = SCSI_CDB10_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = size;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBuffer         = buffer;
		spt.spt.SenseInfoOffset    = offsetof(SPT_DIRECT_BUFFER, senseArea);
		spt.spt.Cdb[0]             = 0x37; // Read Defect Data
		spt.spt.Cdb[1]             = lun << 5;
		spt.spt.Cdb[2]             = ((list & 3) << 3) + (fmt & 3);	// bit:4==Plsi, bit:3==Glist bit0-2==Format
	//	spt.spt.Cdb[3]             = 0;
	//	spt.spt.Cdb[4]             = 0;
	//	spt.spt.Cdb[5]             = 0;
	//	spt.spt.Cdb[6]             = 0;
		spt.spt.Cdb[7]             = (BYTE)((size >> 8) & 0xFF);
		spt.spt.Cdb[8]             = (BYTE)( size       & 0xFF);
	//	spt.spt.Cdb[9]             = 0;
		outsize = sizeof(spt);
		if ( (ret = this->ScsiPassThroughDirect(sizeof(SCSI_PASS_THROUGH_DIRECT), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

TCHAR *	DevCtl::ScsiGetDeviceType(unsigned devType, TCHAR * buffer)
{
	TCHAR		*s;

	switch ( devType & 0x1F )
	{
		case 0x00: return TEXT("Direct access device" );
		case 0x01: return TEXT("Sequential device"    );
		case 0x02: return TEXT("Printer device"       );
		case 0x03: return TEXT("Processor device"     );
		case 0x04: return TEXT("Write-once device"    );
		case 0x05: return TEXT("CD/DVD-ROM device"    );
		case 0x06: return TEXT("Scaner device"        );
		case 0x07: return TEXT("Optical memory device");
		case 0x08: return TEXT("Medium changer device");
		case 0x09: return TEXT("Communication device" );
		default  :
			if ( buffer == NULL )
				return TEXT("Unkown");
			_stprintf(buffer, TEXT("Unkown %02X"), devType & 0x1F);
			return buffer;
	}
	return s;
}

